/*
 * Decompiled with CFR 0.152.
 */
package fire.pb.battle.pvp5;

import fire.pb.battle.pvp5.PvP5Control;
import fire.pb.battle.pvp5.PvP5Helper;
import fire.pb.battle.pvp5.PvP5RoleProxy;
import java.util.HashMap;
import java.util.Map;

public class PvP5CampPolicy {
    private static Map<Integer, Map<Integer, Integer>> campRoleNumMap = new HashMap<Integer, Map<Integer, Integer>>();

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public static void init() {
        Map<Integer, Map<Integer, Integer>> map = campRoleNumMap;
        synchronized (map) {
            campRoleNumMap.clear();
        }
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public static int getRoleNumByCamp(int grade, int camp) {
        Map<Integer, Map<Integer, Integer>> map = campRoleNumMap;
        synchronized (map) {
            Integer roleNum;
            Map<Integer, Integer> campRoleNum = campRoleNumMap.get(grade);
            if (campRoleNum != null && (roleNum = campRoleNum.get(camp)) != null) {
                return roleNum;
            }
        }
        return 0;
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public static int addRoleNumByCamp(int grade, int camp) {
        Map<Integer, Map<Integer, Integer>> map = campRoleNumMap;
        synchronized (map) {
            Integer roleNum;
            Map<Integer, Integer> campRoleNum = campRoleNumMap.get(grade);
            if (campRoleNum == null) {
                campRoleNum = new HashMap<Integer, Integer>();
                campRoleNumMap.put(grade, campRoleNum);
            }
            if ((roleNum = campRoleNum.get(camp)) == null) {
                roleNum = 0;
            }
            roleNum = roleNum + 1;
            campRoleNum.put(camp, roleNum);
            return roleNum;
        }
    }

    public static Policy create(long roleId, int grade) {
        PvP5RoleProxy roleProxy = PvP5RoleProxy.getPvP5RoleProxy(roleId, true);
        if (roleProxy.isTodayJoinActivity()) {
            return new PolicyAlreadyJoin(roleId, grade);
        }
        long now = System.currentTimeMillis();
        long fightStartTime = PvP5Control.getInstance().getFightStartTime();
        long interval = 1800000L;
        if (now > fightStartTime && now - fightStartTime > interval) {
            return new PolicyGeneralCamp(roleId, grade);
        }
        return new PolicyExcellentCamp(roleId, grade);
    }

    public static class PolicyAlreadyJoin
    extends Policy {
        protected PolicyAlreadyJoin(long roleId, int grade) {
            super(roleId, grade);
        }

        @Override
        public void divide() {
            int winNum;
            int battleNum;
            boolean isExcellent;
            PvP5RoleProxy roleProxy = PvP5RoleProxy.getPvP5RoleProxy(this.roleId, true);
            boolean bl = isExcellent = roleProxy.getExcellent() == 1;
            if (isExcellent && (battleNum = roleProxy.getBattleNum()) - (winNum = roleProxy.getWinNum()) >= 2) {
                isExcellent = false;
            }
            this.camp = roleProxy.getCamp();
            this.mapId = PvP5Helper.getMapIdByRaceGrade(this.grade, isExcellent, this.camp);
        }
    }

    public static class PolicyGeneralCamp
    extends Policy {
        protected PolicyGeneralCamp(long roleId, int grade) {
            super(roleId, grade);
        }

        @Override
        public void divide() {
            int roleNumCampB;
            int roleNumCampA = PvP5CampPolicy.getRoleNumByCamp(this.grade, 0);
            this.camp = roleNumCampA <= (roleNumCampB = PvP5CampPolicy.getRoleNumByCamp(this.grade, 1)) ? 0 : 1;
            this.mapId = PvP5Helper.getMapIdByRaceGrade(this.grade, false, this.camp);
        }
    }

    public static class PolicyExcellentCamp
    extends Policy {
        public PolicyExcellentCamp(long roleId, int grade) {
            super(roleId, grade);
        }

        @Override
        public void divide() {
            int roleNumCampB;
            int roleNumCampA = PvP5CampPolicy.getRoleNumByCamp(this.grade, 0);
            this.camp = roleNumCampA <= (roleNumCampB = PvP5CampPolicy.getRoleNumByCamp(this.grade, 1)) ? 0 : 1;
            this.mapId = PvP5Helper.getMapIdByRaceGrade(this.grade, true, this.camp);
        }
    }

    public static abstract class Policy {
        protected final long roleId;
        protected final int grade;
        protected int camp = 0;
        protected int mapId = 0;

        protected Policy(long roleId, int grade) {
            this.roleId = roleId;
            this.grade = grade;
        }

        public abstract void divide();

        int getCamp() {
            return this.camp;
        }

        int getMapId() {
            return this.mapId;
        }
    }
}

